/*
	CGI Source for Guest book ver 1.0

	Author	: Kang Jul Ki (Master 2nd)
	Hompage : http://sel.chonbuk.ac.kr/~jkkang/
	Email	: jkkang@sel.chonbuk.ac.kr

	Date	: February 23, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc 2.7 (unix available)
	Comment:
		*For Win95 user
			- You should have a Compiler supporting 32-bit
			- For example, Visual C++ 4.x, Borlandc 4.5, 5.0
			- GCC for Dos
		*The reason for 32-bit compiler
			- HTTP is based on 32bit input/out
		*Description for my c source(guest.c)
			- I decided to make public my CGI guest book source.
			- When I was a beginner on CGI, I had a difficulty on
			- making my guest book. Though I was a professional C programmer,
			- I had no knowledge about CGI and GuestBook.
			- So I'll be happy if a lot of CGI beginner'll get a help from my source.

	Copyright (c) 1997, Software Engineering Lab. All rights reserved.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>
#include "mycgi.h"

FILE_HEADER	fheader;
RECORD		rcd;

char	fname[100] = "/usr1/user/jkkang/public_html/bbs/"; /* Path & File name*/
char	szHtmlFname[100] = "";
char szMyHtml[100] = "/usr1/user/jkkang/public_html/bbs/guest.html";

/*
** The entry - main()
*/
void main(argc, argv)
int argc;
char *argv[];
{
    int		i, cl;
    char		*whdomain, *whip, whtime[20], whdate[20], *browser;
    entry		inparam[MAX_ENTRIES];
    time_t	tmp_time1;
    struct	tm *tmp_time2;
    char		temp[100] = "",  szDate[50] = "";
    FILE		*fp, *html_fpt;
    int		ch, nTotal;
    
    printf("Content-type: text/html%c%c", LF, LF);
				
    whdomain = getenv("REMOTE_HOST");
    whip     = getenv("REMOTE_ADDR");
    browser  = getenv("HTTP_USER_AGENT");

    tmp_time1 = time(0);
    tmp_time2 = localtime(&tmp_time1);
    strftime(whdate, 99, "%Y%m%d", tmp_time2);
    strftime(whtime, 99, "%H%M", tmp_time2);

    sprintf(szDate, "%s %s", whdate, whtime);
    cl = (int)atoi((char *)getenv("CONTENT_LENGTH"));
    
    for(i=0;cl && (!feof(stdin));i++)
    {
        inparam[i].f_val = (char *)fmakeword(stdin,'&',&cl);
        plustospace(inparam[i].f_val);
        unescape_url(inparam[i].f_val);
        inparam[i].f_name = (char *)makeword(inparam[i].f_val,'=');
    }

    /* Show error message if not write name */
    if (strlen(inparam[0].f_val) <= 0 || strlen(inparam[2].f_val) <= 0) {
	    /* Return result into HTML document		*/
	    /* Just write into stdout and exit(1)	*/
		printf("<html>%c", LF);
		printf("<body bgcolor=\"ffffff\" background=\"/~jkkang/Image/psbbackcolor.jpg\">%c", LF);
		printf("<center><img border=0 src=\"/~jkkang/Image/guest.gif\"></center><br>%c", LF);
        printf("<font size=3>湮 ̸  ּ!!!</font><br>%c", LF);
        printf("<font size=3>You should write your name and title!!!</font>%c", LF);
		printf("<br><br><br>%c", LF);
		printf("<center><a href=\"/textpost.html\"><img border=0 src=\"/~jkkang/Image/before.gif\"></a></center>%c", LF);

		printf("</body>%c", LF);
		printf("</html>%c", LF);
		exit(0);
    }

    /* Make file name & path */
   
    strcat(fname, inparam[6].f_val);	/* inparam[4].f_val is data file name*/	
    strcat(fname, ".dat");
    
    fp = fopen(fname, "r+");
    
    if (fp == NULL) {				/* If file is not exist	*/
		fp = fopen(fname, "w");		/* create file		*/

		sprintf(fheader.szTotal, "%d", 0);
		fwrite(&fheader, HEADER_SIZE, 1, fp);
    }
   
    fseek(fp, 0L, SEEK_SET);
    fread(&fheader, HEADER_SIZE, 1, fp);	/* read header	*/

    sscanf(fheader.szTotal, "%d", &nTotal);
    nTotal++;
    sprintf(rcd.szNumber, "%d", nTotal);
    sprintf(fheader.szTotal, "%d", nTotal);

    strcpy(rcd.szName, inparam[0].f_val);
    strcpy(rcd.szEmail, inparam[1].f_val);
    strcpy(rcd.szDate, whdate);
    strcpy(rcd.szTitle, inparam[2].f_val);

    sprintf(szHtmlFname, "/usr1/user/jkkang/public_html/bbs/%s%d.html", inparam[6].f_val, nTotal);
    
    sprintf(rcd.szHtmlName, "%s%d.html", inparam[6].f_val, nTotal);

    fseek(fp, 0L, SEEK_SET);
    fwrite(&fheader, HEADER_SIZE, 1, fp);

    fseek(fp, 0L, SEEK_END);
    fwrite(&rcd, RECORD_SIZE, 1, fp);
    fclose(fp);
    
    fp = fopen(fname, "r");
    MakeHtmlPage(fp, nTotal);

    fclose(fp);

    /* inparam[3].f_val is comment	*/
    html_fpt = fopen(szHtmlFname, "w+");

    MakeEachHtmlPage(html_fpt, inparam[3].f_val, whdomain, szDate);

    fclose(html_fpt);

    fp = fopen(szMyHtml, "r");
    while ((ch=getc(fp)) != EOF)
		putchar(ch);
    fclose(fp);
}

void MakeHtmlPage(FILE *in, int nTotal)
{
	int	i, idx;
	FILE	*fp;
	RECORD	buf;

	fp = fopen(szMyHtml, "w+");		/* New make file	*/

	fprintf(fp, "<html>%c", LF);
	fprintf(fp, "<body bgcolor=\"ffffff\" background=\"/~jkkang/Image/psbbackcolor.jpg\">%c", LF);

	fprintf(fp, "<center>%c", LF);
	fprintf(fp, "<img src=\"/~jkkang/Image/guest.gif\" width=240 height=60 border=0>%c", LF);
	fprintf(fp, "<br><br><center><a href=/~jkkang/textpost.html><img src=\"/~jkkang/Image/posting.gif\" align=absmiddle border=0></a></center>%c", LF);
	fprintf(fp, "<table border=0 width=480 cellspace=3>%c", LF);
		fprintf(fp, "<tr>%c", LF);
			fprintf(fp, "<td valign=buttom>%c", LF);
			fprintf(fp, "<img align=left border=0 src=\"/~jkkang/Image/icon-proposal.gif\">%c", LF);
			
			fprintf(fp, "<br>%c", LF);
			fprintf(fp, "<img width=420 src=\"/~jkkang/Image/blue_line.gif\">%c", LF);
			fprintf(fp, "</td>%c", LF);
		fprintf(fp, "</tr>%c", LF);
	fprintf(fp, "</table>%c", LF);
	fprintf(fp, "</center>%c", LF);

	fprintf(fp, "<center>%c", LF);
	
	fprintf(fp, "<table border=0 cellspace=3 align=absmiddle><tr><th><pre>  ۹ȣ  </pre></th><th><pre>  ۾  </pre></th><th><pre>  ۾¥  </pre></th><th><pre>    </pre></th></tr>%c", LF);
	
	for (i=1, idx=0; i<=nTotal; i++, idx++) {
		fseek(in, (long)(RECORD_SIZE*(-i)), SEEK_END);
		fread(&buf, RECORD_SIZE, 1, in);
		
		fprintf(fp, "<tr>");
		fprintf(fp, "<td align=center>%s</td>", buf.szNumber);
		fprintf(fp, "<td align=center>%s</td>", buf.szName);
		fprintf(fp, "<td align=center>%s</td>", buf.szDate);
		
		/*fprintf(fp, "<td>%d</td>", buf.nCount);	*/
		
		fprintf(fp, "<td><a href=\"http://sel.chonbuk.ac.kr/~jkkang/bbs/%s\">%s</a></td></tr>%c%c", buf.szHtmlName, buf.szTitle, LF, LF);
		
		if (idx > 50) break;
	}
	fprintf(fp, "</table>%c", LF);
	fprintf(fp, "</center>%c", LF);
	fprintf(fp, "<br><br><center><a href=/~jkkang/textpost.html><img src=\"/~jkkang/Image/posting.gif\" align=absmiddle border=0></a></center>%c", LF);

	fprintf(fp, "<p>%c", LF);
	fprintf(fp, "<center>%c", LF);
	fprintf(fp, "<img src=\"/~jkkang/Image/line.gif\">%c", LF);
	fprintf(fp, "<br>%c", LF);
	
	fprintf(fp, "<font size=-1>Copyright <font size=4>&copy</font> 1996,%c", LF);
	fprintf(fp, "<b>Software Engineering Lab. All rights reserved.</b></br>%c", LF);
	fprintf(fp, "<a href=\"mailto:jkkang@sel.chonbuk.ac.kr\">jkkang@sel.chonbuk.ac.kr</a></br>%c", LF);
	fprintf(fp, "</font></center>%c", LF);
	fprintf(fp, "</body>%c", LF);
	fprintf(fp, "</html>%c", LF);

	fclose(fp);
}

/*
** guestbook10.html  ȭ 
*/
void MakeEachHtmlPage(FILE *fp, char *buf, char *url, char *szDate)
{
	int	i;

	fprintf(fp, "<html>%c", LF);
	fprintf(fp, "<body bgcolor=\"ffffff\" background=\"/~jkkang/Image/psbbackcolor.jpg\">%c", LF);
	fprintf(fp, "<table border=0><font size=3><caption><b>%s...</b></caption></font>%c", rcd.szTitle, LF);
	fprintf(fp, "<tr><th>۹ȣ</th><td>%s</td></tr>%c", rcd.szNumber, LF);
	fprintf(fp, "<tr><th>۾</th><td>%s</td><th>۾¥</th><td>%s</td></tr>%c",
				rcd.szName, szDate, LF);
	fprintf(fp, "<tr><th>E-mail</th><td><a href=mailto:%s>%s</a></td>",
				rcd.szEmail, rcd.szEmail);
	fprintf(fp, "<th>URL</th><td><a href=\"http://%s\">%s</a></td></tr></table>%c", url, url, LF);

	fprintf(fp, "<img width=420 src=\"/~jkkang/Image/blue_line.gif\">%c", LF);
	fprintf(fp, "<br><br>%c", LF);
	
	/*
	** Write contents in the file
	*/
	for (i=0; i<(int)strlen(buf); i++) {
	    if (*(buf+i) == CF)
			fprintf(fp, "<br>");
	    else
		     putc(*(buf+i), fp);
	}
	
	fprintf(fp, "<br><br>%c", LF);
	fprintf(fp, "<img src=\"/~jkkang/Image/line.gif\"><br>%c", LF);
	fprintf(fp, "<font size=-1>Copyright <font size=4>&copy</font> 1996,%c", LF);
	fprintf(fp, "<b>Software Engineering Lab. All rights reserved.</b></br>%c", LF);
	fprintf(fp, "<a href=\"mailto:jkkang@sel.chonbuk.ac.kr\">jkkang@sel.chonbuk.ac.kr</a></br>%c", LF);
	fprintf(fp, "</font>%c", LF);
	fprintf(fp, "</body>%c", LF);
	fprintf(fp, "</html>%c", LF);
}
